"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.withGraphql = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

var _apolloBoost = _interopRequireDefault(require("apollo-boost"));

var traverse = _interopRequireWildcard(require("traverse"));

var _lodash = _interopRequireDefault(require("lodash.clonedeep"));

const options = new Map();

const getOptions = name => {
  if (!clients.has(name)) {
    if (typeof window !== 'undefined') {
      const opts = window.___graphqlUniversal[name];

      if (!opts) {
        throw new Error('GraphQL Universal: No options "' + name + '".');
      }

      if (!opts.url) {
        throw new Error('GraphQL Universal: Could not get "url" for "' + name + '".');
      }

      if (!opts.typeName) {
        throw new Error('GraphQL Universal: Could not get "typeName" for "' + name + '".');
      }

      options.set(name, Object.assign({
        client: new _apolloBoost.default({
          uri: opts.url
        })
      }, opts));
    }
  }

  return options.get(name);
};

const withGraphql = WrappedComponent => {
  var _temp;

  return _temp = class extends _react.default.Component {
    constructor(...args) {
      super(...args);
      (0, _defineProperty2.default)(this, "state", {
        data: this.props.data
      });
      (0, _defineProperty2.default)(this, "graphql", (fieldName, {
        query,
        variables
      }) => {
        // Get options for graphql source plugin
        const _getOptions = getOptions(fieldName),
              client = _getOptions.client,
              typeName = _getOptions.typeName;

        if (query && query.source) {
          const updatedQuery = (0, _lodash.default)((0, _graphqlTag.default)(query.source));
          const updatedRoot = updatedQuery.definitions[0].selectionSet.selections.find(selection => selection.name && selection.name.kind === 'Name' && selection.name.value === fieldName);

          if (updatedRoot) {
            updatedQuery.definitions[0].selectionSet.selections = updatedRoot.selectionSet.selections;
            traverse(updatedQuery).forEach(function (x) {
              if (this.isLeaf && this.parent && this.parent.key === 'name') {
                if (this.parent.parent && this.parent.parent.node.kind === 'NamedType') {
                  if (typeof x === 'string' && x.indexOf(`${typeName}_`) === 0) {
                    this.update(x.substr(typeName.length + 1));
                  }
                }
              }
            });
            const rootValue = this.state.data && this.state.data[rootName] || {};
            client.query({
              query: updatedQuery,
              fetchPolicy: 'network-only',
              variables
            }).then(res => {
              this.setState({
                data: Object.assign({}, this.state.data, {
                  [rootName]: Object.assign({}, rootValue, res.data)
                })
              });
            });
          }
        }
      });
    }

    render() {
      return _react.default.createElement(WrappedComponent, (0, _extends2.default)({}, this.props, {
        graphql: this.graphql,
        data: this.state.data
      }));
    }

  }, _temp;
};

exports.withGraphql = withGraphql;